import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.math.BigInteger; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Every_Icon_Editor_1_1 extends PApplet {

// -----------------------------------------------------------------
// Every Icon Editor (v1.1)
// by Patrick LeMieux
// patrick-lemieux.com
// 20:45:00, February 28, 2014
//
// Inspired by Every Icon
// by John Simon Jr.
// numeral.com
// 9:42:30, January 27, 1997
// -----------------------------------------------------------------

// Import Libraries


// Initialize Variables
PFont f = createFont("Arial", 9, true);

boolean mouseBlack = false;
boolean mouseWhite = false;

int[][] grid = new int[32][32];

BigInteger two = new BigInteger("2");
BigInteger hundred = new BigInteger("100");
BigInteger secondsInMin = new BigInteger("60");
BigInteger secondsInHour = new BigInteger("3600");
BigInteger secondsInDay = new BigInteger("86400");
BigInteger secondsInYear = new BigInteger("31557600"); // 31536000 non-leap, 31557600 leap, 31556952 precice leap
BigInteger christToSimon = new BigInteger("63022894950"); // 62979759750 non-leap, 63022894950 leap, 63021600894 precice leap

BigInteger holder1 =  new BigInteger("0");
BigInteger holder2 = new BigInteger("0");
BigInteger holder3 = new BigInteger("0");
BigInteger totalSeconds = new BigInteger("0");
BigInteger remainder = new BigInteger("0");
BigInteger secs = new BigInteger("0");
BigInteger minusSecs = new BigInteger("0");
BigInteger mins = new BigInteger("0");
BigInteger minusMins = new BigInteger("0");
BigInteger hours = new BigInteger("0");
BigInteger minusHours = new BigInteger("0");
BigInteger days = new BigInteger("0");
BigInteger minusDays = new BigInteger("0");
BigInteger years = new BigInteger("0");
BigInteger minusYears = new BigInteger("0");
BigInteger leap = new BigInteger("0");

String month = ".";
int screenShot = 1;

public void setup() {
  frame.setTitle("Every Icon Editor v1.1");

  size(225, 440);
  noSmooth();
  fill(255);
  background(255);
  
  // Reset
  grid = new int[32][32];
  fill(255);
  stroke(255);
  rect(0, 0, 225, 440);

  stroke(128);
  for (int k = 0; k <= 32; k++) {
    line (0, k*7, 224, k*7);
    line (k*7, 0, k*7, 224);
  }

  fill(255);
  stroke(255);
  rect(0, 315, 224, 100);

  textFont(f);       
  textAlign(LEFT);
  fill(0);
  stroke(0);
  
  text("Save", 1, 230, 223, 100);
  text("Reset", 199, 230, 223, 100);
  
  text("Title:                 Every Icon Editor", 1, 265, 223, 100);
  text("Author:              Patrick LeMieux", 1, 277, 223, 100);
  text("Version:            Electronic Book Review v1.1", 1, 289, 223, 100);
  
  text("Projected Time:  9:42:30, January 27, 1997", 1, 315, 223, 100);
  
  text("(" + Character.toString((char)0x2184) + ") 2014 Patrick LeMieux - patrick-lemieux.com", 1, 425, 223, 100);
  //println("The total seconds are " + totalSeconds);
}

public void draw() {
  // Save
  if (mouseX > 0 && mouseX < 24 && mouseY > 229 && mouseY < 242) {
    stroke(0);
    line(0, 241, 22, 241);
  } else {
    stroke(255);
    line(0, 241, 22, 241);
  }
  // Reset
  if (mouseX > 196 && mouseX < 225 && mouseY > 229 && mouseY < 242) {
    stroke(0);
    line(198, 241, 223, 241);
  } else {
    stroke(255);
    line(198, 241, 223, 241);
  }
  // Link
  if (mouseX > 109 && mouseX < 198 && mouseY > 425 && mouseY < 440) {
    stroke(0);
    line(111, 436, 196, 436);
  } else {
    stroke(255);
    line(111, 436, 196, 436);
  }
}

public void mouseDragged() {
  editIcon();
}

public void mouseClicked() {
  editIcon();
}

public void mouseReleased() {
  mouseBlack = false;
  mouseWhite = false;
  // Save
  if (mouseX > 0 && mouseX < 27 && mouseY > 230 && mouseY < 242) {
    saveFrame("Every_Icon_Editor-" + screenShot + ".png");
    screenShot++;
  }
  // Reset
  if (mouseX > 196 && mouseX < 225 && mouseY > 230 && mouseY < 242) {
    setup();
  }
  // Link
  if (mouseX > 109 && mouseX < 198 && mouseY > 425 && mouseY < 440) {
    link("http://patrick-lemieux.com"); 
  }
}

public void editIcon() {
  if (mouseY > 0 && mouseY < 224 && mouseX > 0 && mouseX < 224) {
    int roundedY = round(mouseY/7);
    int roundedX = round(mouseX/7);
    // turn BLACK
    if (grid[roundedY][roundedX] == 0 && !mouseWhite) {
      mouseBlack = true;
      fill(0);
      stroke(0);
      rect(roundedX*7+1, roundedY*7+1, 5, 5);
      grid[roundedY][roundedX] = 1;
      //println("");
      //println(roundedX + ", " + roundedY + " = BLACK");
    }
    // turn WHITE
    else if (grid[roundedY][roundedX] == 1 && !mouseBlack) {
      mouseWhite = true;
      fill(255);
      stroke(255);
      rect(roundedX*7+1, roundedY*7+1, 5, 5);
      grid[roundedY][roundedX] = 0;
      //println("");
      //println(roundedX + ", " + roundedY + " = WHITE");
    }

    // tally TOTAL
    totalSeconds = new BigInteger("0");

    for (int i = 0; i < 32; i++) {
      for (int j = 0;  j < 32; j++) {
        //print(grid[i][j]);
        if (grid[i][j] != 0) {
          holder1 = two.pow(j + i*32);
          holder2 = new BigInteger(str(grid[i][j]));
          holder3 = holder1.multiply(holder2);
          holder3 = holder3.divide(hundred);
          totalSeconds = totalSeconds.add(holder3);
          //println ("At row " + i + ", column " + j + ", cell " + (j + i*32) + ", 2^" + (j + i*32) + " = " + holder1);
          //println ("Total seconds = " + totalSeconds);
        }
      }
    }

    //Correct for when Every Icon began
    totalSeconds = totalSeconds.add(christToSimon);

    years = totalSeconds.divide(secondsInYear);
    minusYears = years.multiply(secondsInYear);
    remainder = totalSeconds.subtract(minusYears);
    //println(remainder);

    days = remainder.divide(secondsInDay);
    minusDays = days.multiply(secondsInDay);
    remainder = remainder.subtract(minusDays);
    //println(remainder);

    leap = years.remainder(new BigInteger("4"));
    int leap4 = leap.intValue();
    leap = years.remainder(new BigInteger("100"));
    int leap100 = leap.intValue();
    leap = years.remainder(new BigInteger("400"));
    int leap400 = leap.intValue();

    int daysInt = days.intValue();
    //int isLeap = leap.compareTo(new BigInteger("0"));

    if ((leap4 == 0 && leap100 != 0) || (leap400 == 0)) {
      if (daysInt > 335) {
        daysInt -= 335;
        month = "December";
      } 
      else if (daysInt > 305) {
        daysInt -= 305;
        month = "November";
      } 
      else if (daysInt > 274) {
        daysInt -= 274;
        month = "October";
      } 
      else if (daysInt > 244) {
        daysInt -= 244;
        month = "September";
      } 
      else if (daysInt > 213) {
        daysInt -= 213;
        month = "August";
      } 
      else if (daysInt > 182) {
        daysInt -= 182;
        month = "July";
      } 
      else if (daysInt > 152) {
        daysInt -= 152;
        month = "June";
      } 
      else if (daysInt > 121) {
        daysInt -= 121;
        month = "May";
      } 
      else if (daysInt > 91) {
        daysInt -= 91;
        month = "April";
      } 
      else if (daysInt > 60) {
        daysInt -= 60;
        month = "March";
      } 
      else if (daysInt > 32) {
        daysInt -= 32;
        month = "February";
      } 
      else {
        month = "January";
      }
    } 
    else {
      if (daysInt > 334) {
        daysInt -= 334;
        month = "December";
      } 
      else if (daysInt > 304) {
        daysInt -= 304;
        month = "November";
      } 
      else if (daysInt > 273) {
        daysInt -= 273;
        month = "October";
      } 
      else if (daysInt > 243) {
        daysInt -= 243;
        month = "September";
      } 
      else if (daysInt > 212) {
        daysInt -= 212;
        month = "August";
      } 
      else if (daysInt > 181) {
        daysInt -= 181;
        month = "July";
      } 
      else if (daysInt > 151) {
        daysInt -= 151;
        month = "June";
      } 
      else if (daysInt > 120) {
        daysInt -= 120;
        month = "May";
      } 
      else if (daysInt > 90) {
        daysInt -= 90;
        month = "April";
      } 
      else if (daysInt > 59) {
        daysInt -= 59;
        month = "March";
      } 
      else if (daysInt > 31) {
        daysInt -= 31;
        month = "February";
      } 
      else {
        month = "January";
      }
    }

    hours = remainder.divide(secondsInHour);
    minusHours = hours.multiply(secondsInHour);
    remainder = remainder.subtract(minusHours);
    //println(remainder);

    mins = remainder.divide(secondsInMin);
    minusMins = mins.multiply(secondsInMin);
    secs = remainder.subtract(minusMins);
    //println(remainder);

    fill(255);
    stroke(255);
    rect(0, 315, 224, 100);

    fill(0);
    stroke(0);
    text("Projected Time:  " + hours + ":" + mins + ":" + secs + ", " + month + " " + daysInt + ", " + years, 1, 315, 223, 100);
    //println("The total seconds are " + totalSeconds);
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Every_Icon_Editor_1_1" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
